// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/featurestore_online_service.proto

#include "google/cloud/aiplatform/v1/internal/featurestore_online_serving_metadata_decorator.h"
#include "google/cloud/common_options.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/url_encode.h"
#include "google/cloud/status_or.h"
#include <google/cloud/aiplatform/v1/featurestore_online_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

FeaturestoreOnlineServingServiceMetadata::
    FeaturestoreOnlineServingServiceMetadata(
        std::shared_ptr<FeaturestoreOnlineServingServiceStub> child,
        std::multimap<std::string, std::string> fixed_metadata,
        std::string api_client_header)
    : child_(std::move(child)),
      fixed_metadata_(std::move(fixed_metadata)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

StatusOr<google::cloud::aiplatform::v1::ReadFeatureValuesResponse>
FeaturestoreOnlineServingServiceMetadata::ReadFeatureValues(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::ReadFeatureValuesRequest const& request) {
  SetMetadata(
      context,
      absl::StrCat("entity_type=", internal::UrlEncode(request.entity_type())));
  return child_->ReadFeatureValues(context, request);
}

std::unique_ptr<google::cloud::internal::StreamingReadRpc<
    google::cloud::aiplatform::v1::ReadFeatureValuesResponse>>
FeaturestoreOnlineServingServiceMetadata::StreamingReadFeatureValues(
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::aiplatform::v1::StreamingReadFeatureValuesRequest const&
        request) {
  SetMetadata(
      *context,
      absl::StrCat("entity_type=", internal::UrlEncode(request.entity_type())));
  return child_->StreamingReadFeatureValues(std::move(context), request);
}

StatusOr<google::cloud::aiplatform::v1::WriteFeatureValuesResponse>
FeaturestoreOnlineServingServiceMetadata::WriteFeatureValues(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::WriteFeatureValuesRequest const& request) {
  SetMetadata(
      context,
      absl::StrCat("entity_type=", internal::UrlEncode(request.entity_type())));
  return child_->WriteFeatureValues(context, request);
}

void FeaturestoreOnlineServingServiceMetadata::SetMetadata(
    grpc::ClientContext& context, std::string const& request_params) {
  context.AddMetadata("x-goog-request-params", request_params);
  SetMetadata(context);
}

void FeaturestoreOnlineServingServiceMetadata::SetMetadata(
    grpc::ClientContext& context) {
  for (auto const& kv : fixed_metadata_) {
    context.AddMetadata(kv.first, kv.second);
  }
  context.AddMetadata("x-goog-api-client", api_client_header_);
  auto const& options = internal::CurrentOptions();
  if (options.has<UserProjectOption>()) {
    context.AddMetadata("x-goog-user-project",
                        options.get<UserProjectOption>());
  }
  auto const& authority = options.get<AuthorityOption>();
  if (!authority.empty()) context.set_authority(authority);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google
