// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/prediction_service.proto

#include "google/cloud/aiplatform/v1/internal/prediction_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/aiplatform/v1/prediction_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

PredictionServiceStub::~PredictionServiceStub() = default;

StatusOr<google::cloud::aiplatform::v1::PredictResponse>
DefaultPredictionServiceStub::Predict(
    grpc::ClientContext& client_context,
    google::cloud::aiplatform::v1::PredictRequest const& request) {
  google::cloud::aiplatform::v1::PredictResponse response;
  auto status = grpc_stub_->Predict(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::api::HttpBody> DefaultPredictionServiceStub::RawPredict(
    grpc::ClientContext& client_context,
    google::cloud::aiplatform::v1::RawPredictRequest const& request) {
  google::api::HttpBody response;
  auto status = grpc_stub_->RawPredict(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

std::unique_ptr<google::cloud::internal::StreamingReadRpc<
    google::cloud::aiplatform::v1::StreamingPredictResponse>>
DefaultPredictionServiceStub::ServerStreamingPredict(
    std::shared_ptr<grpc::ClientContext> client_context,
    google::cloud::aiplatform::v1::StreamingPredictRequest const& request) {
  auto stream =
      grpc_stub_->ServerStreamingPredict(client_context.get(), request);
  return std::make_unique<google::cloud::internal::StreamingReadRpcImpl<
      google::cloud::aiplatform::v1::StreamingPredictResponse>>(
      std::move(client_context), std::move(stream));
}

StatusOr<google::cloud::aiplatform::v1::ExplainResponse>
DefaultPredictionServiceStub::Explain(
    grpc::ClientContext& client_context,
    google::cloud::aiplatform::v1::ExplainRequest const& request) {
  google::cloud::aiplatform::v1::ExplainResponse response;
  auto status = grpc_stub_->Explain(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google
