// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/vizier_service.proto

#include "google/cloud/aiplatform/v1/internal/vizier_logging_decorator.h"
#include "google/cloud/internal/log_wrapper.h"
#include "google/cloud/status_or.h"
#include <google/cloud/aiplatform/v1/vizier_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

VizierServiceLogging::VizierServiceLogging(
    std::shared_ptr<VizierServiceStub> child, TracingOptions tracing_options,
    std::set<std::string> const& components)
    : child_(std::move(child)),
      tracing_options_(std::move(tracing_options)),
      stream_logging_(components.find("rpc-streams") != components.end()) {}

StatusOr<google::cloud::aiplatform::v1::Study>
VizierServiceLogging::CreateStudy(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::CreateStudyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::CreateStudyRequest const& request) {
        return child_->CreateStudy(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Study> VizierServiceLogging::GetStudy(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::GetStudyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::GetStudyRequest const& request) {
        return child_->GetStudy(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::ListStudiesResponse>
VizierServiceLogging::ListStudies(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::ListStudiesRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::ListStudiesRequest const& request) {
        return child_->ListStudies(context, request);
      },
      context, request, __func__, tracing_options_);
}

Status VizierServiceLogging::DeleteStudy(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::DeleteStudyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::DeleteStudyRequest const& request) {
        return child_->DeleteStudy(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Study>
VizierServiceLogging::LookupStudy(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::LookupStudyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::LookupStudyRequest const& request) {
        return child_->LookupStudy(context, request);
      },
      context, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
VizierServiceLogging::AsyncSuggestTrials(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::aiplatform::v1::SuggestTrialsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          google::cloud::CompletionQueue& cq,
          std::shared_ptr<grpc::ClientContext> context,
          google::cloud::aiplatform::v1::SuggestTrialsRequest const& request) {
        return child_->AsyncSuggestTrials(cq, std::move(context), request);
      },
      cq, std::move(context), request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Trial>
VizierServiceLogging::CreateTrial(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::CreateTrialRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::CreateTrialRequest const& request) {
        return child_->CreateTrial(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Trial> VizierServiceLogging::GetTrial(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::GetTrialRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::GetTrialRequest const& request) {
        return child_->GetTrial(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::ListTrialsResponse>
VizierServiceLogging::ListTrials(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::ListTrialsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::ListTrialsRequest const& request) {
        return child_->ListTrials(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Trial>
VizierServiceLogging::AddTrialMeasurement(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::AddTrialMeasurementRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::AddTrialMeasurementRequest const&
                 request) {
        return child_->AddTrialMeasurement(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Trial>
VizierServiceLogging::CompleteTrial(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::CompleteTrialRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::aiplatform::v1::CompleteTrialRequest const& request) {
        return child_->CompleteTrial(context, request);
      },
      context, request, __func__, tracing_options_);
}

Status VizierServiceLogging::DeleteTrial(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::DeleteTrialRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::DeleteTrialRequest const& request) {
        return child_->DeleteTrial(context, request);
      },
      context, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
VizierServiceLogging::AsyncCheckTrialEarlyStoppingState(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::cloud::aiplatform::v1::
                 CheckTrialEarlyStoppingStateRequest const& request) {
        return child_->AsyncCheckTrialEarlyStoppingState(cq, std::move(context),
                                                         request);
      },
      cq, std::move(context), request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::Trial> VizierServiceLogging::StopTrial(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::StopTrialRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::StopTrialRequest const& request) {
        return child_->StopTrial(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::aiplatform::v1::ListOptimalTrialsResponse>
VizierServiceLogging::ListOptimalTrials(
    grpc::ClientContext& context,
    google::cloud::aiplatform::v1::ListOptimalTrialsRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::aiplatform::v1::ListOptimalTrialsRequest const&
                 request) {
        return child_->ListOptimalTrials(context, request);
      },
      context, request, __func__, tracing_options_);
}

future<StatusOr<google::longrunning::Operation>>
VizierServiceLogging::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::longrunning::GetOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::longrunning::GetOperationRequest const& request) {
        return child_->AsyncGetOperation(cq, std::move(context), request);
      },
      cq, std::move(context), request, __func__, tracing_options_);
}

future<Status> VizierServiceLogging::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::shared_ptr<grpc::ClientContext> context,
    google::longrunning::CancelOperationRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](google::cloud::CompletionQueue& cq,
             std::shared_ptr<grpc::ClientContext> context,
             google::longrunning::CancelOperationRequest const& request) {
        return child_->AsyncCancelOperation(cq, std::move(context), request);
      },
      cq, std::move(context), request, __func__, tracing_options_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google
