// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/datacatalog/v1/policytagmanagerserialization.proto

#include "google/cloud/datacatalog/v1/internal/policy_tag_manager_serialization_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/datacatalog/v1/policytagmanagerserialization.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace datacatalog_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

PolicyTagManagerSerializationStub::~PolicyTagManagerSerializationStub() =
    default;

StatusOr<google::cloud::datacatalog::v1::Taxonomy>
DefaultPolicyTagManagerSerializationStub::ReplaceTaxonomy(
    grpc::ClientContext& client_context,
    google::cloud::datacatalog::v1::ReplaceTaxonomyRequest const& request) {
  google::cloud::datacatalog::v1::Taxonomy response;
  auto status =
      grpc_stub_->ReplaceTaxonomy(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::datacatalog::v1::ImportTaxonomiesResponse>
DefaultPolicyTagManagerSerializationStub::ImportTaxonomies(
    grpc::ClientContext& client_context,
    google::cloud::datacatalog::v1::ImportTaxonomiesRequest const& request) {
  google::cloud::datacatalog::v1::ImportTaxonomiesResponse response;
  auto status =
      grpc_stub_->ImportTaxonomies(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::datacatalog::v1::ExportTaxonomiesResponse>
DefaultPolicyTagManagerSerializationStub::ExportTaxonomies(
    grpc::ClientContext& client_context,
    google::cloud::datacatalog::v1::ExportTaxonomiesRequest const& request) {
  google::cloud::datacatalog::v1::ExportTaxonomiesResponse response;
  auto status =
      grpc_stub_->ExportTaxonomies(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace datacatalog_v1_internal
}  // namespace cloud
}  // namespace google
