// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/autoscaling_policies.proto

#include "google/cloud/dataproc/v1/internal/autoscaling_policy_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/dataproc/v1/autoscaling_policies.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace dataproc_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

AutoscalingPolicyServiceStub::~AutoscalingPolicyServiceStub() = default;

StatusOr<google::cloud::dataproc::v1::AutoscalingPolicy>
DefaultAutoscalingPolicyServiceStub::CreateAutoscalingPolicy(
    grpc::ClientContext& client_context,
    google::cloud::dataproc::v1::CreateAutoscalingPolicyRequest const&
        request) {
  google::cloud::dataproc::v1::AutoscalingPolicy response;
  auto status =
      grpc_stub_->CreateAutoscalingPolicy(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dataproc::v1::AutoscalingPolicy>
DefaultAutoscalingPolicyServiceStub::UpdateAutoscalingPolicy(
    grpc::ClientContext& client_context,
    google::cloud::dataproc::v1::UpdateAutoscalingPolicyRequest const&
        request) {
  google::cloud::dataproc::v1::AutoscalingPolicy response;
  auto status =
      grpc_stub_->UpdateAutoscalingPolicy(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dataproc::v1::AutoscalingPolicy>
DefaultAutoscalingPolicyServiceStub::GetAutoscalingPolicy(
    grpc::ClientContext& client_context,
    google::cloud::dataproc::v1::GetAutoscalingPolicyRequest const& request) {
  google::cloud::dataproc::v1::AutoscalingPolicy response;
  auto status =
      grpc_stub_->GetAutoscalingPolicy(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse>
DefaultAutoscalingPolicyServiceStub::ListAutoscalingPolicies(
    grpc::ClientContext& client_context,
    google::cloud::dataproc::v1::ListAutoscalingPoliciesRequest const&
        request) {
  google::cloud::dataproc::v1::ListAutoscalingPoliciesResponse response;
  auto status =
      grpc_stub_->ListAutoscalingPolicies(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultAutoscalingPolicyServiceStub::DeleteAutoscalingPolicy(
    grpc::ClientContext& client_context,
    google::cloud::dataproc::v1::DeleteAutoscalingPolicyRequest const&
        request) {
  google::protobuf::Empty response;
  auto status =
      grpc_stub_->DeleteAutoscalingPolicy(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc_v1_internal
}  // namespace cloud
}  // namespace google
