// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/node_groups.proto

#include "google/cloud/dataproc/v1/node_group_controller_connection.h"
#include "google/cloud/dataproc/v1/internal/node_group_controller_connection_impl.h"
#include "google/cloud/dataproc/v1/internal/node_group_controller_option_defaults.h"
#include "google/cloud/dataproc/v1/internal/node_group_controller_stub_factory.h"
#include "google/cloud/dataproc/v1/internal/node_group_controller_tracing_connection.h"
#include "google/cloud/dataproc/v1/node_group_controller_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/common_options.h"
#include "google/cloud/credentials.h"
#include "google/cloud/grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataproc_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

NodeGroupControllerConnection::~NodeGroupControllerConnection() = default;

future<StatusOr<google::cloud::dataproc::v1::NodeGroup>>
NodeGroupControllerConnection::CreateNodeGroup(
    google::cloud::dataproc::v1::CreateNodeGroupRequest const&) {
  return google::cloud::make_ready_future<
      StatusOr<google::cloud::dataproc::v1::NodeGroup>>(
      Status(StatusCode::kUnimplemented, "not implemented"));
}

future<StatusOr<google::cloud::dataproc::v1::NodeGroup>>
NodeGroupControllerConnection::ResizeNodeGroup(
    google::cloud::dataproc::v1::ResizeNodeGroupRequest const&) {
  return google::cloud::make_ready_future<
      StatusOr<google::cloud::dataproc::v1::NodeGroup>>(
      Status(StatusCode::kUnimplemented, "not implemented"));
}

StatusOr<google::cloud::dataproc::v1::NodeGroup>
NodeGroupControllerConnection::GetNodeGroup(
    google::cloud::dataproc::v1::GetNodeGroupRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

std::shared_ptr<NodeGroupControllerConnection>
MakeNodeGroupControllerConnection(std::string const& location,
                                  Options options) {
  internal::CheckExpectedOptions<CommonOptionList, GrpcOptionList,
                                 UnifiedCredentialsOptionList,
                                 NodeGroupControllerPolicyOptionList>(options,
                                                                      __func__);
  options = dataproc_v1_internal::NodeGroupControllerDefaultOptions(
      location, std::move(options));
  auto background = internal::MakeBackgroundThreadsFactory(options)();
  auto stub = dataproc_v1_internal::CreateDefaultNodeGroupControllerStub(
      background->cq(), options);
  return dataproc_v1_internal::MakeNodeGroupControllerTracingConnection(
      std::make_shared<dataproc_v1_internal::NodeGroupControllerConnectionImpl>(
          std::move(background), std::move(stub), std::move(options)));
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc_v1
}  // namespace cloud
}  // namespace google
