// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/page.proto

#include "google/cloud/dialogflow_cx/internal/pages_tracing_stub.h"
#include "google/cloud/internal/grpc_opentelemetry.h"

namespace google {
namespace cloud {
namespace dialogflow_cx_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

PagesTracingStub::PagesTracingStub(std::shared_ptr<PagesStub> child)
    : child_(std::move(child)), propagator_(internal::MakePropagator()) {}

StatusOr<google::cloud::dialogflow::cx::v3::ListPagesResponse>
PagesTracingStub::ListPages(
    grpc::ClientContext& context,
    google::cloud::dialogflow::cx::v3::ListPagesRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.cloud.dialogflow.cx.v3.Pages",
                                     "ListPages");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(context, *span, child_->ListPages(context, request));
}

StatusOr<google::cloud::dialogflow::cx::v3::Page> PagesTracingStub::GetPage(
    grpc::ClientContext& context,
    google::cloud::dialogflow::cx::v3::GetPageRequest const& request) {
  auto span =
      internal::MakeSpanGrpc("google.cloud.dialogflow.cx.v3.Pages", "GetPage");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(context, *span, child_->GetPage(context, request));
}

StatusOr<google::cloud::dialogflow::cx::v3::Page> PagesTracingStub::CreatePage(
    grpc::ClientContext& context,
    google::cloud::dialogflow::cx::v3::CreatePageRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.cloud.dialogflow.cx.v3.Pages",
                                     "CreatePage");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(context, *span,
                           child_->CreatePage(context, request));
}

StatusOr<google::cloud::dialogflow::cx::v3::Page> PagesTracingStub::UpdatePage(
    grpc::ClientContext& context,
    google::cloud::dialogflow::cx::v3::UpdatePageRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.cloud.dialogflow.cx.v3.Pages",
                                     "UpdatePage");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(context, *span,
                           child_->UpdatePage(context, request));
}

Status PagesTracingStub::DeletePage(
    grpc::ClientContext& context,
    google::cloud::dialogflow::cx::v3::DeletePageRequest const& request) {
  auto span = internal::MakeSpanGrpc("google.cloud.dialogflow.cx.v3.Pages",
                                     "DeletePage");
  auto scope = opentelemetry::trace::Scope(span);
  internal::InjectTraceContext(context, *propagator_);
  return internal::EndSpan(context, *span,
                           child_->DeletePage(context, request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<PagesStub> MakePagesTracingStub(
    std::shared_ptr<PagesStub> stub) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return std::make_shared<PagesTracingStub>(std::move(stub));
#else
  return stub;
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx_internal
}  // namespace cloud
}  // namespace google
