// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/webhook.proto

#include "google/cloud/dialogflow_cx/internal/webhooks_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/dialogflow/cx/v3/webhook.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_cx_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

WebhooksStub::~WebhooksStub() = default;

StatusOr<google::cloud::dialogflow::cx::v3::ListWebhooksResponse>
DefaultWebhooksStub::ListWebhooks(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::cx::v3::ListWebhooksRequest const& request) {
  google::cloud::dialogflow::cx::v3::ListWebhooksResponse response;
  auto status = grpc_stub_->ListWebhooks(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dialogflow::cx::v3::Webhook>
DefaultWebhooksStub::GetWebhook(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::cx::v3::GetWebhookRequest const& request) {
  google::cloud::dialogflow::cx::v3::Webhook response;
  auto status = grpc_stub_->GetWebhook(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dialogflow::cx::v3::Webhook>
DefaultWebhooksStub::CreateWebhook(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::cx::v3::CreateWebhookRequest const& request) {
  google::cloud::dialogflow::cx::v3::Webhook response;
  auto status = grpc_stub_->CreateWebhook(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dialogflow::cx::v3::Webhook>
DefaultWebhooksStub::UpdateWebhook(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::cx::v3::UpdateWebhookRequest const& request) {
  google::cloud::dialogflow::cx::v3::Webhook response;
  auto status = grpc_stub_->UpdateWebhook(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultWebhooksStub::DeleteWebhook(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::cx::v3::DeleteWebhookRequest const& request) {
  google::protobuf::Empty response;
  auto status = grpc_stub_->DeleteWebhook(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx_internal
}  // namespace cloud
}  // namespace google
