// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/version.proto

#include "google/cloud/dialogflow_es/internal/versions_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/dialogflow/v2/version.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

VersionsStub::~VersionsStub() = default;

StatusOr<google::cloud::dialogflow::v2::ListVersionsResponse>
DefaultVersionsStub::ListVersions(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::v2::ListVersionsRequest const& request) {
  google::cloud::dialogflow::v2::ListVersionsResponse response;
  auto status = grpc_stub_->ListVersions(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dialogflow::v2::Version>
DefaultVersionsStub::GetVersion(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::v2::GetVersionRequest const& request) {
  google::cloud::dialogflow::v2::Version response;
  auto status = grpc_stub_->GetVersion(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dialogflow::v2::Version>
DefaultVersionsStub::CreateVersion(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::v2::CreateVersionRequest const& request) {
  google::cloud::dialogflow::v2::Version response;
  auto status = grpc_stub_->CreateVersion(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::dialogflow::v2::Version>
DefaultVersionsStub::UpdateVersion(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::v2::UpdateVersionRequest const& request) {
  google::cloud::dialogflow::v2::Version response;
  auto status = grpc_stub_->UpdateVersion(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultVersionsStub::DeleteVersion(
    grpc::ClientContext& client_context,
    google::cloud::dialogflow::v2::DeleteVersionRequest const& request) {
  google::protobuf::Empty response;
  auto status = grpc_stub_->DeleteVersion(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es_internal
}  // namespace cloud
}  // namespace google
