// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/dashboard/v1/dashboards_service.proto

#include "google/cloud/monitoring/dashboard/v1/internal/dashboards_metadata_decorator.h"
#include "google/cloud/common_options.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/url_encode.h"
#include "google/cloud/status_or.h"
#include <google/monitoring/dashboard/v1/dashboards_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace monitoring_dashboard_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

DashboardsServiceMetadata::DashboardsServiceMetadata(
    std::shared_ptr<DashboardsServiceStub> child,
    std::multimap<std::string, std::string> fixed_metadata,
    std::string api_client_header)
    : child_(std::move(child)),
      fixed_metadata_(std::move(fixed_metadata)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

StatusOr<google::monitoring::dashboard::v1::Dashboard>
DashboardsServiceMetadata::CreateDashboard(
    grpc::ClientContext& context,
    google::monitoring::dashboard::v1::CreateDashboardRequest const& request) {
  SetMetadata(context,
              absl::StrCat("parent=", internal::UrlEncode(request.parent())));
  return child_->CreateDashboard(context, request);
}

StatusOr<google::monitoring::dashboard::v1::ListDashboardsResponse>
DashboardsServiceMetadata::ListDashboards(
    grpc::ClientContext& context,
    google::monitoring::dashboard::v1::ListDashboardsRequest const& request) {
  SetMetadata(context,
              absl::StrCat("parent=", internal::UrlEncode(request.parent())));
  return child_->ListDashboards(context, request);
}

StatusOr<google::monitoring::dashboard::v1::Dashboard>
DashboardsServiceMetadata::GetDashboard(
    grpc::ClientContext& context,
    google::monitoring::dashboard::v1::GetDashboardRequest const& request) {
  SetMetadata(context,
              absl::StrCat("name=", internal::UrlEncode(request.name())));
  return child_->GetDashboard(context, request);
}

Status DashboardsServiceMetadata::DeleteDashboard(
    grpc::ClientContext& context,
    google::monitoring::dashboard::v1::DeleteDashboardRequest const& request) {
  SetMetadata(context,
              absl::StrCat("name=", internal::UrlEncode(request.name())));
  return child_->DeleteDashboard(context, request);
}

StatusOr<google::monitoring::dashboard::v1::Dashboard>
DashboardsServiceMetadata::UpdateDashboard(
    grpc::ClientContext& context,
    google::monitoring::dashboard::v1::UpdateDashboardRequest const& request) {
  SetMetadata(context,
              absl::StrCat("dashboard.name=",
                           internal::UrlEncode(request.dashboard().name())));
  return child_->UpdateDashboard(context, request);
}

void DashboardsServiceMetadata::SetMetadata(grpc::ClientContext& context,
                                            std::string const& request_params) {
  context.AddMetadata("x-goog-request-params", request_params);
  SetMetadata(context);
}

void DashboardsServiceMetadata::SetMetadata(grpc::ClientContext& context) {
  for (auto const& kv : fixed_metadata_) {
    context.AddMetadata(kv.first, kv.second);
  }
  context.AddMetadata("x-goog-api-client", api_client_header_);
  auto const& options = internal::CurrentOptions();
  if (options.has<UserProjectOption>()) {
    context.AddMetadata("x-goog-user-project",
                        options.get<UserProjectOption>());
  }
  auto const& authority = options.get<AuthorityOption>();
  if (!authority.empty()) context.set_authority(authority);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_dashboard_v1_internal
}  // namespace cloud
}  // namespace google
