// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/pubsublite/v1/topic_stats.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_PUBSUBLITE_INTERNAL_TOPIC_STATS_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_PUBSUBLITE_INTERNAL_TOPIC_STATS_STUB_H

#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/pubsublite/v1/topic_stats.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace pubsublite_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class TopicStatsServiceStub {
 public:
  virtual ~TopicStatsServiceStub() = 0;

  virtual StatusOr<google::cloud::pubsublite::v1::ComputeMessageStatsResponse>
  ComputeMessageStats(
      grpc::ClientContext& context,
      google::cloud::pubsublite::v1::ComputeMessageStatsRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::pubsublite::v1::ComputeHeadCursorResponse>
  ComputeHeadCursor(
      grpc::ClientContext& context,
      google::cloud::pubsublite::v1::ComputeHeadCursorRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::pubsublite::v1::ComputeTimeCursorResponse>
  ComputeTimeCursor(
      grpc::ClientContext& context,
      google::cloud::pubsublite::v1::ComputeTimeCursorRequest const&
          request) = 0;
};

class DefaultTopicStatsServiceStub : public TopicStatsServiceStub {
 public:
  explicit DefaultTopicStatsServiceStub(
      std::unique_ptr<
          google::cloud::pubsublite::v1::TopicStatsService::StubInterface>
          grpc_stub)
      : grpc_stub_(std::move(grpc_stub)) {}

  StatusOr<google::cloud::pubsublite::v1::ComputeMessageStatsResponse>
  ComputeMessageStats(
      grpc::ClientContext& client_context,
      google::cloud::pubsublite::v1::ComputeMessageStatsRequest const& request)
      override;

  StatusOr<google::cloud::pubsublite::v1::ComputeHeadCursorResponse>
  ComputeHeadCursor(
      grpc::ClientContext& client_context,
      google::cloud::pubsublite::v1::ComputeHeadCursorRequest const& request)
      override;

  StatusOr<google::cloud::pubsublite::v1::ComputeTimeCursorResponse>
  ComputeTimeCursor(
      grpc::ClientContext& client_context,
      google::cloud::pubsublite::v1::ComputeTimeCursorRequest const& request)
      override;

 private:
  std::unique_ptr<
      google::cloud::pubsublite::v1::TopicStatsService::StubInterface>
      grpc_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace pubsublite_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_PUBSUBLITE_INTERNAL_TOPIC_STATS_STUB_H
