// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/retail/v2/serving_config_service.proto

#include "google/cloud/retail/v2/internal/serving_config_metadata_decorator.h"
#include "google/cloud/common_options.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/internal/url_encode.h"
#include "google/cloud/status_or.h"
#include <google/cloud/retail/v2/serving_config_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace retail_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

ServingConfigServiceMetadata::ServingConfigServiceMetadata(
    std::shared_ptr<ServingConfigServiceStub> child,
    std::multimap<std::string, std::string> fixed_metadata,
    std::string api_client_header)
    : child_(std::move(child)),
      fixed_metadata_(std::move(fixed_metadata)),
      api_client_header_(
          api_client_header.empty()
              ? google::cloud::internal::GeneratedLibClientHeader()
              : std::move(api_client_header)) {}

StatusOr<google::cloud::retail::v2::ServingConfig>
ServingConfigServiceMetadata::CreateServingConfig(
    grpc::ClientContext& context,
    google::cloud::retail::v2::CreateServingConfigRequest const& request) {
  SetMetadata(context,
              absl::StrCat("parent=", internal::UrlEncode(request.parent())));
  return child_->CreateServingConfig(context, request);
}

Status ServingConfigServiceMetadata::DeleteServingConfig(
    grpc::ClientContext& context,
    google::cloud::retail::v2::DeleteServingConfigRequest const& request) {
  SetMetadata(context,
              absl::StrCat("name=", internal::UrlEncode(request.name())));
  return child_->DeleteServingConfig(context, request);
}

StatusOr<google::cloud::retail::v2::ServingConfig>
ServingConfigServiceMetadata::UpdateServingConfig(
    grpc::ClientContext& context,
    google::cloud::retail::v2::UpdateServingConfigRequest const& request) {
  SetMetadata(
      context,
      absl::StrCat("serving_config.name=",
                   internal::UrlEncode(request.serving_config().name())));
  return child_->UpdateServingConfig(context, request);
}

StatusOr<google::cloud::retail::v2::ServingConfig>
ServingConfigServiceMetadata::GetServingConfig(
    grpc::ClientContext& context,
    google::cloud::retail::v2::GetServingConfigRequest const& request) {
  SetMetadata(context,
              absl::StrCat("name=", internal::UrlEncode(request.name())));
  return child_->GetServingConfig(context, request);
}

StatusOr<google::cloud::retail::v2::ListServingConfigsResponse>
ServingConfigServiceMetadata::ListServingConfigs(
    grpc::ClientContext& context,
    google::cloud::retail::v2::ListServingConfigsRequest const& request) {
  SetMetadata(context,
              absl::StrCat("parent=", internal::UrlEncode(request.parent())));
  return child_->ListServingConfigs(context, request);
}

StatusOr<google::cloud::retail::v2::ServingConfig>
ServingConfigServiceMetadata::AddControl(
    grpc::ClientContext& context,
    google::cloud::retail::v2::AddControlRequest const& request) {
  SetMetadata(context,
              absl::StrCat("serving_config=",
                           internal::UrlEncode(request.serving_config())));
  return child_->AddControl(context, request);
}

StatusOr<google::cloud::retail::v2::ServingConfig>
ServingConfigServiceMetadata::RemoveControl(
    grpc::ClientContext& context,
    google::cloud::retail::v2::RemoveControlRequest const& request) {
  SetMetadata(context,
              absl::StrCat("serving_config=",
                           internal::UrlEncode(request.serving_config())));
  return child_->RemoveControl(context, request);
}

void ServingConfigServiceMetadata::SetMetadata(
    grpc::ClientContext& context, std::string const& request_params) {
  context.AddMetadata("x-goog-request-params", request_params);
  SetMetadata(context);
}

void ServingConfigServiceMetadata::SetMetadata(grpc::ClientContext& context) {
  for (auto const& kv : fixed_metadata_) {
    context.AddMetadata(kv.first, kv.second);
  }
  context.AddMetadata("x-goog-api-client", api_client_header_);
  auto const& options = internal::CurrentOptions();
  if (options.has<UserProjectOption>()) {
    context.AddMetadata("x-goog-user-project",
                        options.get<UserProjectOption>());
  }
  auto const& authority = options.get<AuthorityOption>();
  if (!authority.empty()) context.set_authority(authority);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace retail_v2_internal
}  // namespace cloud
}  // namespace google
